cBessel functions and Hankel functions from Numerical recipes pp236-239.
      subroutine bessjy(x,xnu,rj,ry,rjp,ryp)
      integer maxit
      real rj,rjp,ry,ryp,x,xnu,xmin
      double precision eps,fpmin,pi
      parameter (eps=1.e-16,fpmin=1.e-30,maxit=10000,xmin=2.,
     &        pi=3.141592653589793d0)

      integer i,isign,l,nl
      double precision a,b,br,bi,c,cr,ci,d,del,del1,den,di,dlr,dli,
     &       dr,e,f,fact,fact2,fact3,ff,gam,gam1,gam2,gammi,gampl,h,
     &       p,pimu,pimu2,q,r,rjl,rjl1,rjmu,rjp1,rjpl,rjtemp,ry1,
     &       rymu,rymup,rytemp,sum, sum1,temp,w,x2,xi,xi2,xmu,xmu2
      if (x.le.0..or.xnu.lt.0.) pause 'bad arguments in bessjy'
      if (x.lt.xmin) then
        nl=int(xnu+0.5d0)
      else
        nl=max(0,int(xnu-x+1.5d0))
      endif
      xmu=xnu-nl
      xmu2=xmu*xmu
      xi=1.0d0/x
      xi2=2.0d0*xi
      w=xi2/pi
      isign=1
      h=xnu*xi
      if(h.lt.fpmin) h=fpmin
      b=xi2*xnu
      d=0.d0
      c=h
      do i=1,maxit
        b=b+xi2
        d=b-d
        if (abs(d).lt.fpmin) d=fpmin
        c=b-1.d0/c
        if(abs(c).lt.fpmin) c=fpmin
        d=1.0d0/d
        del=c*d
        h=del*h
        if (d.lt.0.d0) isign=-isign
        if (abs(del-1.0d0).lt.eps) goto 1
      enddo
      pause 'x too large in bessjy, try asymptotic expansion'
 1    continue
      rjl=isign*fpmin
      rjpl=h*rjl
      rjl1=rjl
      rjp1=rjpl
      fact=xnu*xi
      do l=nl,1,-1
        rjtemp=fact*rjl+rjpl
        fact=fact-xi
        rjpl=fact*rjtemp-rjl
        rjl=rjtemp
      enddo
      if (rjl.eq.0.d0) rjl=eps
      f=rjpl/rjl
      if (x.lt.xmin) then
        x2=0.5d0*x
        pimu=pi*xmu
        if (abs(pimu).lt.eps) then
          fact=1.0d0
        else
          fact=pimu/sin(pimu)
        endif
        d=-log(x2)
        e=xmu*d
        if (abs(e).lt.eps) then
          fact2=1.0d0
        else
          fact2=sinh(e)/e
        endif
        call beschb (xmu,gam1,gam2,gampl,gammi)
        ff= 2.d0/pi*fact*(gam1*cosh(e)+gam2*fact2*d)
        e=exp(e)
        p=e/(gampl*pi)
        q=1.d0/(e*pi*gammi)
        pimu2=0.5d0*pimu
        if (abs(pimu2).lt.eps) then
          fact3=1.d0
        else
          fact3=sin(pimu2)/pimu2
        endif
        r=pi*pimu2*fact3*fact3
        c=1.d0
        d=-x2*x2
        sum=ff+r*q
        sum1=p
        do i=1,maxit
          ff=(i*ff+p+q)/(i*i-xmu2)
          c=c*d/i
          p=p/(i-xmu)
          q=q/(i+xmu)
          del=c*(ff+r*q)
          sum=sum+del
          del1=c*p-i*del
          sum1=sum1+del1
          if (abs(del).lt.(1.d0+abs(sum))*eps) goto 2
        enddo
        pause 'bessy series failed to converge'
2       continue
        rymu=-sum
        ry1=-sum1*xi2
        rymup=xmu*xi*rymu-ry1
        rjmu=w/(rymup-f*rymu)
      else
        a=.25d0-xmu2
        p=-.5d0*xi
        q=1.d0
        br=2.d0*x
        bi=2.d0
        fact=a*xi/(p*p+q*q)
        cr=br+q*fact
        ci=bi+p*fact
        den=br*br+bi*bi
        dr=br/den
        di=-bi/den
        dlr=cr*dr-ci*di
        dli=cr*di+ci*dr
        temp=p*dlr-q*dli
        q=p*dli+q*dlr
        p=temp
        do i=2,maxit
          a=a+2*(i-1)
          bi=bi+2.d0
          dr=a*dr+br
          di=a*di+bi
          if (abs(dr)+abs(di).lt.fpmin) dr=fpmin
          fact=a/(cr*cr+ci*ci)
          cr=br+cr*fact
          ci=bi-ci*fact
          if (abs(cr)+abs(ci).lt.fpmin) cr=fpmin
          den=dr*dr+di*di
          dr=dr/den
          di=-di/den
          dlr=cr*dr-ci*di
          dli=cr*di+ci*dr
          temp=p*dlr-q*dli
          q=p*dli+q*dlr
          p=temp
          if (abs(dlr-1.d0)+abs(dli).lt.eps) goto 3
        enddo
        pause 'cf2 failed n bessjy'
 3      continue
        gam=(p-f)/q
        rjmu=sqrt(w/((p-f)*gam+q))
        rjmu=sign(rjmu,rjl)
        rymu=rjmu*gam
        rymup=rymu*(p+q/gam)
        ry1=xmu*xi*rymu-rymup
      endif
      fact=rjmu/rjl
      rj=rjl1*fact
      rjp=rjp1*fact
      do i=1,nl
        rytemp=(xmu+i)*xi2*ry1-rymu
        rymu=ry1
        ry1=rytemp
      enddo
      ry=rymu
      ryp=xnu*xi*rymu-ry1
      return
      end
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine beschb(x,gam1,gam2,gampl,gammi)
      integer nuse1,nuse2
      double precision gam1,gam2,gammi,gampl,x
      parameter (nuse1=7,nuse2=8)
      real xx,c1(7),c2(8),chebev
      save c1,c2
      data c1/-1.142022680371172d0,6.516511267076d-3,
     &        3.08709017308d-4,-3.470626964d-6,6.943764d-9,
     &        3.6780d-11,-1.36d-13/
      data c2/1.843740587300906d0,-.076852840844786d0,
     &        1.271927136655d-3,-4.971736704d-6,-3.3126120d-8,
     &        2.42310d-10,-1.70d-13,-1.d-15/
      xx=8.d0*x*x-1.d0
      gam1=chebev(-1.,1.,c1,nuse1,xx)
      gam2=chebev(-1.,1.,c2,nuse2,xx)
      gampl=gam2-x*gam1
      gammi=gam2+x*gam1
      return
      end
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      function chebev(a,b,c,m,x)
      integer m
      real chebev,a,b,x,c(m)
c     double precision chebev,a,b,x,c(m)
      integer j
      real d,dd,sv,y,y2
c     double precision d,dd,sv,y,y2
      if ((x-a)*(x-b).gt.0.d0) pause 'x not in range in chebev'
      d=0.
      dd=0.
      y=(2.*x-a-b)/(b-a)
      y2=2.*y
      do j=m,2,-1
        sv=d
        d=y2*d-dd+c(j)
        dd=sv
      enddo
      chebev=y*d-dd+0.5*c(1)
      return
      end
