
% reading input data
filename=input('filename ?','s');
filein=fopen(filename,'r');
nnx=fscanf(filein,'%f',1);
ddx=fscanf(filein,'%f',1);
nny=fscanf(filein,'%f',1);
ddy=fscanf(filein,'%f',1);
xstep=0:ddx:(nnx-1)*ddx;
ystep=0:ddy:(nny-1)*ddy;

filestru=input('filename for the structure (0 for no structure)?','s');
if not(filestru(1:1)=='0') ;
  %filestru='ani2./structure.mod';
  filest=fopen(filestru,'r') ;
  % reading the structure
  nst=fscanf(filest,'%f',1) ;
  for ist =1:nst  ;
    temp=fscanf(filest,'%f',2);
    xstu(ist)=temp(1) ;
    ystu(ist)=temp(2) ;
  end;
%  xstu(nst+1)=xstu(1) ;
%  ystu(nst+1)=ystu(1) ;
end;

% reading the wavefield
norm=fscanf(filein,'%f',3);
nter=fscanf(filein,'%f',1);

% if norm(2)=norm(3), we conclude we have an incoming Love wave
ilove=0;
if norm(2)==norm(3); ilove=1; end;

for iter=1:nter;
% convention in using (i,j) opposite from the one in coupling
% in order to get plots in the correct coordinate-system.
  [nmode,err]=fscanf(filein,'%f',1);
  for im=1:nmode;
    for i=1:nnx;
      for j=1:nny;
        [tmp,err]=fscanf(filein,'%f',7);
        u(j,i,iter,im,1:7)=tmp(:);
      end;
    end;
  end;
end;


% set amplitude ratio y/x or x/y into 8. component 
if ilove==0; u(:,:,:,nmode,8)=u(:,:,:,nmode,2)./u(:,:,:,nmode,1); end;
if ilove==1; u(:,:,:,nmode,8)=u(:,:,:,nmode,1)./u(:,:,:,nmode,2); end;

% normalises the amplitudes
u(:,:,:,:,1)=u(:,:,:,:,1)./norm(1);
u(:,:,:,:,2)=u(:,:,:,:,2)./norm(2);
u(:,:,:,:,3)=u(:,:,:,:,3)./norm(3);

%options for what to plot 
idxmode=input('enter 1 for all modes, 0 for sum only :');
idxiter=input('enter 1 for all iterations, 0 for last only :');
if idxmode==0; idxmode=nmode; end; 
if idxiter==0; idxiter=nter ; end; 

%   calculate optimum number of windows
nwin=1;
if idxiter~=nter;
  if nter<=16; nwin=4; end;
  if nter<=9; nwin=3; end;
  if nter<=4; nwin=2; end;
  if nter==1; nwin=1; end;
end;

%   choose y-downwards to be added after each contour-call
%    axis 'ij'

for im=idxmode:nmode
        %choose here what to plot
% nplots=3;
% indx=[1,2,3]; % three amplitudes 
% if im==nmode;  nplots=4;
% indx=[1,2,3,8]; % three amplitudes and an amplitude ratio
% end;
  nplots=4;
  indx=[1,2,3,4]; % three amplitudes and a phase
  if im==nmode;  nplots=5;
  indx=[1,2,3,4,8]; % three amplitudes, a phase and an amplitude ratio
  end;
  for iplot=1:nplots;
    i=indx(iplot);
    AA=min(u(:,:,idxiter:nter,im,i));
    A=min(AA);
    amn=min(A); 
    clear AA,A;
    AA=max(u(:,:,idxiter:nter,im,i));
    A=max(AA);
    amx=max(A); 
    clear AA,A;
    ncolors=9;
    nlines=ncolors+1;
    cv=[amn,amx] ;

    if amn~=amx;
    for iter=idxiter:nter;
      if i==8;
        A=min(u(:,:,iter,im,i));
        amn=min(A); 
        clear A;
        A=max(u(:,:,iter,im,i));
        amx=max(A); 
        clear A;
        ncolors=9;
        nlines=ncolors+1;
        cv=[amn,amx];
      end;

      if idxiter~=nter; subplot(nwin,nwin,iter); end;
      hold on;
         if i==1, string='displacement x';, end;
         if i==2, string='displacement y';, end;
         if i==3, string='displacement z';, end;
         if i==8, string='displacement ratio y/x';, end;
         if i==4, string='phase of dominant component'; end;
         if i==5, string='phase difference ';, end;
         if i==7, string='total phase ';
           imn=floor(amn/pi);, imx=ceil(amx/pi);, nlines=imx-imn+1;
           amn=imn*pi;, amx=imx*pi;, end;
      v=linspace(amn,amx,nlines); 
      caxis(cv);
%     colormap (gray(ncolors))
      colormap (jet(64))
      contour (xstep,ystep,u(:,:,iter,im,i),v);
      ch=colorbar;
      set (ch,'YTick',v);
      axis 'ij'
      axis 'equal'
      axis ([0,nnx*ddx,0,nny*ddy])
      string=strcat(filename,';..',string,'; mode ',int2str(im));
      title(string)
      if not(filestru(1:1)=='0'); plot(xstu,ystu,'k'); end;
      hold off;
      clear C,v;
    end;
    pause
    end;
    clf
  end;

                 %plotting the ellipse in the horizontal plane
  for it=1:21;
    cosit(it)=cos(it*0.314159);
    sinit(it)=sin(it*0.314159);
  end;
% for iter=idxiter:nter;
    iter=nter;
%   nx1=1;
    nx1=2;
    nx2=nnx;
    nx=nx2-nx1+1;
    ny1=1;
    ny2=nny;
    ny=ny2-ny1+1;
    hold on;
    nthin=round(nnx/10);
    AA=max(u(nx1:nthin:nx2,ny1:nthin:ny2,iter,im,1:2));
    A=max(AA);
    amx=max(A) ;
    clear AA,A;
    for i=ny1:nthin:ny2;
       y0=(i-1)*ddy;
       for j=nx1:nthin:nx2;
          x0=(j-1)*ddx;
          cosphi=cos(u(i,j,iter,im,6));
          sinphi=sin(u(i,j,iter,im,6));
          if ilove==0;
            xell=u(i,j,iter,im,1)*cosit;
            yell=u(i,j,iter,im,2)*(cosit*cosphi-sinit*sinphi);
          else;
            xell=-u(i,j,iter,im,1)*(cosit*cosphi+sinit*sinphi);
            yell=-u(i,j,iter,im,2)*cosit;
          end;
%   magnification necessary in some cases
%         xell=xell*1.35;
%         yell=yell*1.35;
%
          xell=x0+xell*ddx/amx/2*nthin;
          yell=y0+yell*ddy/amx/2*nthin;
          plot(xell,yell,'b');
          arrow ([xell(19),xell(18)],[yell(19),yell(18)],0.75*ddx,1);
          axis 'equal'
       end;
    end;
    set (gca,'YDir','reverse','FontSize',14,'FontWeight','bold');
    axis ([(nx1-1-nthin/2)*ddx,(nx2-1+nthin/2)*ddx,(ny1-1-nthin/2)*ddy,(ny2-1+nthin/2)*ddy]);
    strim=int2str(im);
    string=strcat(filename,'; ellipse in horizontal plane; mode ',strim);
    title(string)
    if not(filestru(1:1)=='0'); plot(xstu,ystu,'k'); end;
%   xlabel ('x-direction (km)')
    if ilove==0;
      ylabel ('incident Rayeigh wave')
    else;
      ylabel ('incident Love wave')
    end;

%   define areas to plot the incoming arrows
    dim=get(gca,'Position');
    xwidth=0.1;
    axes('Position',[dim(1) dim(2) xwidth dim(4)],'Visible','off')
    axis([0 xwidth 0 dim(4)]);

%    arrows for incoming wave 
    xa(1)=0.8*xwidth;
    xa(2)=0.3*xwidth;
    ya(1)=dim(4)*0.20;
    ya(2)=ya(1);
    arrow(xa,ya,0.02,2);
    ya(1)=dim(4)*0.80;
    ya(2)=ya(1);
    arrow(xa,ya,0.02,2);

    pause
    hold off;
    clf
% end;

end;
